----------------------------------------------------------------------------------
-- Summer school on real-world crypto and privacy - Sibenik, Croatia, 2016
-- Authors: Ricardo Chaves & Nele Mentens
-- 
-- Create Date:    05/31/2016 
-- Design Name:    Noekeon
-- Module Name:    NoekeonRoundCommonLoop
-- Target Devices: Xilinx
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity ControlUnit is
    Port ( start : in  STD_LOGIC;
           reset : in  STD_LOGIC;
           clk   : in  STD_LOGIC;
           round : out  STD_LOGIC_VECTOR (3 downto 0);
           selectInput : out  STD_LOGIC;
           done  : out  STD_LOGIC);
end ControlUnit;

architecture Behavioral of ControlUnit is
  signal doing : STD_LOGIC;
  signal roundInt: STD_LOGIC_VECTOR (3 downto 0);
begin


counter: process(clk)
begin  
	if ((clk'event )and (clk = '1')) then  

      if reset = '1' then 
        doing <= '0';
        done  <= '0';
        roundInt <= "0000";
        selectInput <= '1';
      else 
        if start = '1' then
		    roundInt <= "0000";
          selectInput <= '1';
		    doing <= '1'; 
	     else
          selectInput <= '0';
          if doing = '1' then 
		      roundInt <= std_logic_vector(unsigned(RoundInt) + 2 );
            if roundInt = "1100" then 
              done  <= '1';
              doing <= '0'; 
            end if;
           else
            done  <= '0';
	       end if; -- Doing 
        end if;   -- Start
      end if;     -- Reset     
	   	    
	 end if; -- Clk
    
end process counter;

round <= roundInt;


end Behavioral;

